-- SPDX-License-Identifier: CC0-1.0

let Genode = env:DHALL_GENODE

in    λ(testBinary : Genode.Prelude.Map.Entry Text Text)
    → { config =
          Genode.Init::{
          , children =
              toMap
                { solo5 =
                    Genode.Init.Start::{
                    , binary = testBinary.mapKey
                    , exitPropagate = True
                    , resources = { caps = 256, ram = Genode.units.MiB 3 }
                    , routes = [ Genode.ServiceRoute.parent "Timer" ]
                    , config =
                        Some
                          ( Genode.Prelude.XML.text
                              ''
                               <config>
                               	<cmdline>Hello_Solo5</cmdline>
                              </config>
                               ''
                          )
                    }
                }
          }
      , rom = [ testBinary ]
      }
